import { ProxyExec } from './interfaces';
/**
 * Proxy execute On the client side.
 *
 * ## Description
 *
 * `fork()` is very similar to the actor model,
 *  which transfers the corresponding module method to all client threads for execution and returns the result from the first client's response.
 *
 * Note: It does not create new threads, it always runs on all client thread that have already been created.
 *
 * reference: https://en.wikipedia.org/wiki/Actor_model
 */
export declare const fork: ProxyExec;
//# sourceMappingURL=fork.d.ts.map