import { identifierKey, storeKey, injectable, inject, actionIdentifier, optional, PluginModule, modulesKey, containerKey, applyPatches, ModuleRef, createApp, watch, stateKey, state, action, getRef, nameKey } from 'reactant';
export * from 'reactant';
import { createTransport, mockPorts } from 'data-transport';
export * from 'data-transport';
import { LastAction, LastActionOptions } from 'reactant-last-action';
export * from 'reactant-last-action';
import { LOCATION_CHANGE, RouterOptions, Router } from 'reactant-router';
export { RouterOptions, createBrowserHistory, createHashHistory, createMemoryHistory } from 'reactant-router';
import { StorageOptions, Storage } from 'reactant-storage';
export { REHYDRATE, StorageOptions, getRehydrated } from 'reactant-storage';
import { BroadcastChannel } from 'broadcast-channel';

//  Client to Server
var proxyClientActionName = '@@reactant:proxyClient';
var preloadedStateActionName = '@@reactant:preloadedState';
var isClientName = '@@reactant:isClient';
var loadFullStateActionName = '@@reactant:loadFullState';
var syncRouterName = '@@reactant:syncRouter';
var syncClientIdToServerName = '@@reactant:syncClientIdToServer';
var removeClientIdToServerName = '@@reactant:removeClientIdToServer';
// Server to Client
var proxyServerActionName = '@@reactant:proxyServer';
var lastActionName = '@@reactant:lastAction';
var syncToClientsName = '@@reactant:syncToClients';
var syncWorkerRouterName = '@@reactant:syncWorkerRouter';
var syncClientIdsFromClientsName = '@@reactant:syncClientIdsFromClients';
var SharedAppOptions = Symbol('SharedAppOptions');
var storageModuleName = 'Storage';
var routerModuleName = 'Router';
// Coworker
var proxyExecutorKey = Symbol('proxyExecutor');
var proxyWorkerExecuteName = '@@reactant:coworkerProxyWorkerExecute';
var syncStateName = '@@reactant:coworkerSyncState';
var requestSyncAllStateName = '@@reactant:coworkerRequestSyncAllState';
var pushAllStateName = '@@reactant:coworkerPushAllState';
var coworkerKey = Symbol('coworker');
// Redux action types
var syncStateActionName = '@@reactant:syncState';
var syncModuleStateActionName = '@@reactant:syncModuleState';

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/* global Reflect, Promise, SuppressedError, Symbol, Iterator */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    if (typeof b !== "function" && b !== null)
        throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function __decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}

function __param(paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
}

function __metadata(metadataKey, metadataValue) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
}

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function __values(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
}

function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

function __spreadArray(to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
}

typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
    var e = new Error(message);
    return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
};

var createId = function () { return Math.random().toString(36).slice(2); };

/**
 * Port Detector
 *
 * It provides port detection and client/server port switching functions.
 */
var PortDetector = /** @class */ (function () {
    function PortDetector(sharedAppOptions, lastAction) {
        var _this = this;
        this.sharedAppOptions = sharedAppOptions;
        this.lastAction = lastAction;
        this.serverCallbacks = new Set();
        this.clientCallbacks = new Set();
        this.clientDestroyCallbacks = new Set();
        /**
         * client id, it will be generated when the port is client, it is null in server port.
         */
        this.clientId = null;
        /**
         * allow Disable Sync
         */
        this.allowDisableSync = function () { return true; };
        /**
         * client ids, it will collect all the client ids when the port is server, it is an empty array in client port.
         */
        this.clientIds = [];
        /**
         * server hooks for delegate(this, key, args, { _extra: { serverHook: '$hookName' } }) method
         */
        this.serverHooks = {};
        this.isolatedModules = [];
        /**
         * onServer
         *
         * When the port is server, this hook will execute.
         * And allow to return a function that will be executed when the current port is switched to client.
         */
        this.onServer = function (callback) {
            if (typeof callback !== 'function') {
                throw new Error("'onServer' argument should be a function.");
            }
            _this.serverCallbacks.add(callback);
            if (_this.lastHooks &&
                _this.lastHooks.size > 0 &&
                _this.isServer &&
                _this.transport) {
                try {
                    var hook = callback(_this.transport);
                    _this.lastHooks.add(hook);
                }
                catch (e) {
                    console.error(e);
                }
            }
            return function () {
                _this.serverCallbacks.delete(callback);
            };
        };
        /**
         * onClient
         *
         * When the port is client, this hook will execute.
         * And allow to return a function that will be executed when the current port is switched to server.
         */
        this.onClient = function (callback) {
            if (typeof callback !== 'function') {
                throw new Error("'onClient' argument should be a function.");
            }
            _this.clientCallbacks.add(callback);
            if (_this.lastHooks &&
                _this.lastHooks.size > 0 &&
                _this.isClient &&
                _this.transport) {
                try {
                    var hook = callback(_this.transport);
                    _this.lastHooks.add(hook);
                }
                catch (e) {
                    console.error(e);
                }
            }
            return function () {
                _this.clientCallbacks.delete(callback);
            };
        };
        /**
         * emit client destroy event with clientId
         */
        this.onClientDestroy = function (callback) {
            if (typeof callback !== 'function') {
                throw new Error("'onClientDestroy' argument should be a function.");
            }
            _this.clientDestroyCallbacks.add(callback);
            return function () {
                _this.clientDestroyCallbacks.delete(callback);
            };
        };
        this.onClient(function (transport) {
            _this.clientId = createId();
            _this.clientIds = [];
            _this.syncFullState({ forceSync: false });
            var disposeSyncToClients = transport.listen(syncToClientsName, function (fullState) { return __awaiter(_this, void 0, void 0, function () {
                var store;
                return __generator(this, function (_a) {
                    if (!fullState)
                        return [2 /*return*/];
                    store = this[storeKey];
                    store.dispatch({
                        type: "".concat(actionIdentifier, "_").concat(loadFullStateActionName),
                        state: this.getNextState(fullState),
                        _reactant: actionIdentifier,
                    });
                    this.lastAction.sequence =
                        fullState[this.lastAction.stateKey]._sequence;
                    return [2 /*return*/];
                });
            }); });
            transport.emit({ name: syncClientIdToServerName, respond: false }, _this.clientId);
            var disposeSyncClientIds = transport.listen(syncClientIdsFromClientsName, function () { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    if (this.clientId) {
                        // for all clients send current client id to server
                        transport.emit({ name: syncClientIdToServerName, respond: false }, this.clientId);
                    }
                    return [2 /*return*/];
                });
            }); });
            var removeClientIdToServer = function () {
                transport.emit({ name: removeClientIdToServerName, respond: false }, _this.clientId);
            };
            // do not use `unload` event
            // https://developer.chrome.com/docs/web-platform/deprecating-unload
            // the pagehide event is just only triggered in shared worker mode
            window.addEventListener('pagehide', removeClientIdToServer);
            return function () {
                _this.previousPort = 'client';
                disposeSyncToClients === null || disposeSyncToClients === void 0 ? void 0 : disposeSyncToClients();
                disposeSyncClientIds === null || disposeSyncClientIds === void 0 ? void 0 : disposeSyncClientIds();
                window.removeEventListener('pagehide', removeClientIdToServer);
            };
        });
        this.onServer(function (transport) {
            _this.clientId = null;
            transport.emit({ name: syncClientIdsFromClientsName, respond: false });
            var disposeSyncClientId = transport.listen(syncClientIdToServerName, function (clientId) {
                if (!_this.clientIds.includes(clientId)) {
                    _this.clientIds.push(clientId);
                }
            });
            var disposeRemoveClientId = transport.listen(removeClientIdToServerName, function (clientId) {
                var e_1, _a;
                var index = _this.clientIds.findIndex(function (id) { return id === clientId; });
                if (index !== -1) {
                    _this.clientIds.splice(index, 1);
                    var callbacks = _this.clientDestroyCallbacks;
                    try {
                        for (var callbacks_1 = __values(callbacks), callbacks_1_1 = callbacks_1.next(); !callbacks_1_1.done; callbacks_1_1 = callbacks_1.next()) {
                            var callback = callbacks_1_1.value;
                            try {
                                callback(clientId);
                            }
                            catch (e) {
                                console.error(e);
                            }
                        }
                    }
                    catch (e_1_1) { e_1 = { error: e_1_1 }; }
                    finally {
                        try {
                            if (callbacks_1_1 && !callbacks_1_1.done && (_a = callbacks_1.return)) _a.call(callbacks_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                    }
                }
            });
            return function () {
                _this.previousPort = 'server';
                disposeSyncClientId === null || disposeSyncClientId === void 0 ? void 0 : disposeSyncClientId();
                disposeRemoveClientId === null || disposeRemoveClientId === void 0 ? void 0 : disposeRemoveClientId();
            };
        });
    }
    /**
     * all isolated instances state will not be sync to other clients or server.
     */
    PortDetector.prototype.disableShare = function (instance) {
        if (process.env.NODE_ENV !== 'production') {
            if (!this.shared) {
                console.warn("The app is not shared, so it cannot be isolated.");
            }
            if (this.isolatedModules.includes(instance)) {
                console.warn("This module \"".concat(instance.constructor.name, "\" has been disabled for state sharing."));
            }
        }
        this.isolatedModules = this.isolatedModules.concat(instance);
    };
    Object.defineProperty(PortDetector.prototype, "isolatedInstanceKeys", {
        get: function () {
            var _a;
            if (this.lastIsolatedInstances !== this.isolatedModules) {
                this.lastIsolatedInstanceKeys = this.isolatedModules.map(function (instance) { return instance[identifierKey]; });
            }
            return (_a = this.lastIsolatedInstanceKeys) !== null && _a !== void 0 ? _a : [];
        },
        enumerable: false,
        configurable: true
    });
    PortDetector.prototype.hasIsolatedState = function (key) {
        return this.isolatedInstanceKeys.includes(key);
    };
    Object.defineProperty(PortDetector.prototype, "id", {
        get: function () {
            var _a;
            return (_a = this.clientId) !== null && _a !== void 0 ? _a : '__SERVER__';
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PortDetector.prototype, "shared", {
        get: function () {
            return !!(this.sharedAppOptions.port && this.sharedAppOptions.type);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PortDetector.prototype, "name", {
        get: function () {
            var _a;
            return (_a = this.sharedAppOptions.portName) !== null && _a !== void 0 ? _a : 'default';
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PortDetector.prototype, "disableSyncClient", {
        get: function () {
            return (document.visibilityState === 'hidden' &&
                !this.sharedAppOptions.forcedSyncClient &&
                this.allowDisableSync());
        },
        enumerable: false,
        configurable: true
    });
    PortDetector.prototype.detectPort = function (port) {
        var _a;
        return (_a = this.portApp) === null || _a === void 0 ? void 0 : _a[port];
    };
    Object.defineProperty(PortDetector.prototype, "isWorkerMode", {
        get: function () {
            return this.sharedAppOptions.type === 'SharedWorker';
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PortDetector.prototype, "isServerWorker", {
        get: function () {
            return this.isWorkerMode && this.isServer;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PortDetector.prototype, "isServer", {
        get: function () {
            return !!this.detectPort('server');
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PortDetector.prototype, "isClient", {
        get: function () {
            return !!this.detectPort('client');
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PortDetector.prototype, "transports", {
        get: function () {
            var _a;
            return (_a = this.sharedAppOptions.transports) !== null && _a !== void 0 ? _a : {};
        },
        enumerable: false,
        configurable: true
    });
    PortDetector.prototype.setPort = function (currentPortApp, transport) {
        var e_2, _a, e_3, _b;
        this.transport = transport;
        if (this.lastHooks) {
            try {
                for (var _c = __values(this.lastHooks), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var hook = _d.value;
                    try {
                        hook === null || hook === void 0 ? void 0 : hook();
                    }
                    catch (e) {
                        console.error(e);
                    }
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                }
                finally { if (e_2) throw e_2.error; }
            }
        }
        this.lastHooks = new Set();
        this.portApp = currentPortApp;
        var callbacks = this.isClient
            ? this.clientCallbacks
            : this.serverCallbacks;
        try {
            for (var callbacks_2 = __values(callbacks), callbacks_2_1 = callbacks_2.next(); !callbacks_2_1.done; callbacks_2_1 = callbacks_2.next()) {
                var callback = callbacks_2_1.value;
                try {
                    var hook = callback(transport);
                    this.lastHooks.add(hook);
                }
                catch (e) {
                    console.error(e);
                }
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (callbacks_2_1 && !callbacks_2_1.done && (_b = callbacks_2.return)) _b.call(callbacks_2);
            }
            finally { if (e_3) throw e_3.error; }
        }
    };
    PortDetector.prototype.syncToClients = function () {
        var _a;
        var store = this[storeKey];
        if (this.transports.server) {
            (_a = this.transports.server) === null || _a === void 0 ? void 0 : _a.emit({ name: syncToClientsName, respond: false }, store.getState());
        }
        else {
            throw new Error("Failed to 'syncToClients()', 'transports.server' does not exist.");
        }
    };
    PortDetector.prototype.syncFullState = function () {
        return __awaiter(this, arguments, void 0, function (_a) {
            var fullState, store;
            var _b = _a === void 0 ? {} : _a, _c = _b.forceSync, forceSync = _c === void 0 ? true : _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        if (forceSync) {
                            this.syncFullStatePromise = undefined;
                        }
                        if (!this.syncFullStatePromise) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.syncFullStatePromise];
                    case 1:
                        _d.sent();
                        return [2 /*return*/];
                    case 2:
                        if (typeof this.transports.client === 'undefined') {
                            throw new Error("The current client transport does not exist.");
                        }
                        this.syncFullStatePromise = this.transports.client.emit(loadFullStateActionName, !forceSync ? this.lastAction.sequence : -1);
                        return [4 /*yield*/, this.syncFullStatePromise];
                    case 3:
                        fullState = _d.sent();
                        this.syncFullStatePromise = undefined;
                        if (typeof fullState === 'undefined') {
                            throw new Error("Failed to sync full state from server port.");
                        }
                        if (fullState === null ||
                            (!forceSync &&
                                this.lastAction.sequence >
                                    fullState[this.lastAction.stateKey]._sequence))
                            return [2 /*return*/];
                        store = this[storeKey];
                        store.dispatch({
                            type: "".concat(actionIdentifier, "_").concat(loadFullStateActionName),
                            state: this.getNextState(fullState),
                            _reactant: actionIdentifier,
                        });
                        this.lastAction.sequence = fullState[this.lastAction.stateKey]._sequence;
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * ignore router state and isolated state sync for last action
     */
    PortDetector.prototype.getNextState = function (fullState) {
        var store = this[storeKey];
        var currentFullState = store.getState();
        var nextState = __assign(__assign({}, fullState), { router: currentFullState.router });
        if (this.isolatedInstanceKeys.length) {
            this.isolatedInstanceKeys.forEach(function (key) {
                if (key) {
                    nextState[key] = currentFullState[key];
                }
            });
        }
        return nextState;
    };
    /**
     * transform port with new transport
     */
    PortDetector.prototype.transform = function (port, transport) {
        if (port !== 'server' && port !== 'client') {
            throw new Error("The port '".concat(port, "' is not supported."));
        }
        this.sharedAppOptions.transports[port] =
            transport !== null && transport !== void 0 ? transport : this.sharedAppOptions.transports[port];
        this.sharedAppOptions.transform(port);
    };
    var _a;
    PortDetector = __decorate([
        injectable(),
        __param(0, inject(SharedAppOptions)),
        __metadata("design:paramtypes", [Object, typeof (_a = typeof LastAction !== "undefined" && LastAction) === "function" ? _a : Object])
    ], PortDetector);
    return PortDetector;
}());

var ReactantStorage = /** @class */ (function (_super) {
    __extends(ReactantStorage, _super);
    function ReactantStorage(portDetector, options) {
        var _this = _super.call(this, options) || this;
        _this.portDetector = portDetector;
        _this.options = options;
        _this.onRehydrated(function () {
            _this.portDetector.onServer(function () {
                _this.persist();
            });
            _this.portDetector.onClient(function () {
                _this.pause();
            });
            if (_this.portDetector.isServer) {
                _this.portDetector.syncToClients();
            }
        });
        return _this;
    }
    /**
     * set module to storage persistent
     */
    ReactantStorage.prototype.setStorage = function (target, options) {
        return _super.prototype.setStorage.call(this, target, this.options.disableClientRehydrated && this.portDetector.isClient
            ? __assign(__assign({}, options), { blacklist: [], whitelist: [] }) : options);
    };
    ReactantStorage = __decorate([
        injectable({
            name: storageModuleName,
        }),
        __param(1, inject(StorageOptions)),
        __metadata("design:paramtypes", [PortDetector, Object])
    ], ReactantStorage);
    return ReactantStorage;
}(Storage));

var PatchesChecker = /** @class */ (function (_super) {
    __extends(PatchesChecker, _super);
    function PatchesChecker(portDetector, storage) {
        var _this = _super.call(this) || this;
        _this.portDetector = portDetector;
        _this.storage = storage;
        _this.middleware = function (store) { return function (next) { return function (_action) {
            var _patches = _action._patches, type = _action.type, method = _action.method;
            var hasIsolatedState;
            _patches === null || _patches === void 0 ? void 0 : _patches.forEach(function (_a, index) {
                var path = _a.path; _a.op; _a.value;
                var _hasIsolatedState = _this.portDetector.hasIsolatedState("".concat(path[0]));
                // ignore first patch
                if (!index) {
                    hasIsolatedState = _hasIsolatedState;
                }
                else if (hasIsolatedState !== _hasIsolatedState) {
                    var methodName = "".concat(type, ".").concat(method);
                    throw new Error("Update state error: Mixed update of shared state and isolated state is not supported, please check method '".concat(methodName, "'."));
                }
            });
            return next(_action);
        }; }; };
        if (process.env.NODE_ENV !== 'production' && _this.storage) {
            _this.afterCreateStore = function (store) {
                _this.storage.storageSettingMap.forEach(function (_, module) {
                    if (_this.portDetector.isolatedModules.includes(module)) {
                        throw new Error("The module \"".concat(module.constructor.name, "\" has been disabled for state sharing, its module state cannot be enabled for storage."));
                    }
                });
                return store;
            };
        }
        return _this;
    }
    PatchesChecker.prototype.checkPatches = function (oldStateTree, options) {
        options._patches.forEach(function (_a) {
            var op = _a.op, path = _a.path, value = _a.value;
            if (op === 'replace' &&
                (toString.call(value) === '[object Object]' || Array.isArray(value))) {
                var oldState = path.reduce(function (state, _path) { return state === null || state === void 0 ? void 0 : state[_path]; }, oldStateTree);
                if (oldState &&
                    typeof oldState === 'object' &&
                    path[0] !== routerModuleName) {
                    var state = path.join('.');
                    console.warn("The state '".concat(state, "' operation in the method '").concat(options.method, "' of the module '").concat(String(options.type), "'  is a replacement update operation, be sure to check the state '").concat(state, "' update operation and use mutation updates to ensure the minimum set of update patches."));
                }
            }
        });
    };
    PatchesChecker = __decorate([
        injectable(),
        __param(1, optional()),
        __metadata("design:paramtypes", [PortDetector,
            ReactantStorage])
    ], PatchesChecker);
    return PatchesChecker;
}(PluginModule));

var applyMethod = function (app, options) {
    var module = app.instance[modulesKey][options.module];
    if (!module) {
        throw new Error("The module '".concat(options.module, "' is not a multiple instances injected module, and it does not exist."));
    }
    var method = module[options.method];
    if (typeof method !== 'function') {
        throw new Error("The '".concat(options.method, "' method for module '").concat(options.module, "' does not exist."));
    }
    // If the method in main thread and use coworker, it should be proxied for execution to a coworker thread.
    if (module[proxyExecutorKey]) {
        return module[proxyExecutorKey](options);
    }
    return method.apply(module, options.args);
};

var handleServer = function (_a) {
    var _b;
    var app = _a.app, transport = _a.transport, disposeServer = _a.disposeServer, disposeClient = _a.disposeClient, enablePatchesChecker = _a.enablePatchesChecker;
    if (!transport) {
        throw new Error("The server transport does not exist.");
    }
    disposeServer === null || disposeServer === void 0 ? void 0 : disposeServer();
    disposeClient === null || disposeClient === void 0 ? void 0 : disposeClient();
    var container = app.instance[containerKey];
    var lastAction = container.get(LastAction);
    var portDetector = container.get(PortDetector);
    var patchesChecker = enablePatchesChecker
        ? container.get(PatchesChecker)
        : null;
    // eslint-disable-next-line @typescript-eslint/ban-ts-comment
    // @ts-ignore
    if (globalThis.SharedWorkerGlobalScope) {
        var executed_1 = false;
        // before any other event, it should be connected with the first client
        globalThis.addEventListener('connect', function () {
            if (executed_1)
                return;
            executed_1 = true;
            portDetector.setPort({ server: app }, transport);
        });
    }
    else {
        portDetector.setPort({ server: app }, transport);
    }
    var disposeListeners = [];
    disposeListeners.push(transport.listen(isClientName, function () { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
        return [2 /*return*/, true];
    }); }); }));
    disposeListeners.push(transport.listen(loadFullStateActionName, function (sequence) { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
        return [2 /*return*/, lastAction.sequence > sequence ? (_a = app.store) === null || _a === void 0 ? void 0 : _a.getState() : null];
    }); }); }));
    disposeListeners.push(transport.listen(proxyClientActionName, function (options) { return __awaiter(void 0, void 0, void 0, function () {
        var hook, result_1, sequence_1, result, sequence;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!options.hook) return [3 /*break*/, 2];
                    hook = portDetector.serverHooks[options.hook];
                    if (!(typeof hook === 'function')) return [3 /*break*/, 2];
                    return [4 /*yield*/, hook(options)];
                case 1:
                    result_1 = _a.sent();
                    sequence_1 = portDetector.lastAction.sequence;
                    return [2 /*return*/, [sequence_1, result_1]];
                case 2: return [4 /*yield*/, applyMethod(app, options)];
                case 3:
                    result = _a.sent();
                    sequence = portDetector.lastAction.sequence;
                    return [2 /*return*/, [sequence, result]];
            }
        });
    }); }));
    disposeListeners.push(function () { return transport.dispose(); });
    var oldStateTree;
    if (process.env.NODE_ENV !== 'production') {
        oldStateTree = app.store.getState();
    }
    disposeListeners.push((_b = app.store) === null || _b === void 0 ? void 0 : _b.subscribe(function () {
        var _a, _b;
        try {
            if (lastAction.action) {
                var action = lastAction.action;
                if (!((_b = (_a = portDetector.lastAction.options) === null || _a === void 0 ? void 0 : _a.ignoreAction) === null || _b === void 0 ? void 0 : _b.call(_a, action))) {
                    if (process.env.NODE_ENV !== 'production' &&
                        enablePatchesChecker &&
                        patchesChecker &&
                        (action === null || action === void 0 ? void 0 : action._reactant) === actionIdentifier &&
                        action._patches) {
                        patchesChecker.checkPatches(oldStateTree, action);
                    }
                    transport.emit({ name: lastActionName, respond: false }, action);
                }
            }
        }
        finally {
            if (process.env.NODE_ENV !== 'production') {
                oldStateTree = app.store.getState();
            }
        }
    }));
    // app synchronizes state to all clients immediately after switching server port
    if (portDetector.previousPort === 'client') {
        portDetector.syncToClients();
    }
    return function () {
        var e_1, _a;
        try {
            for (var disposeListeners_1 = __values(disposeListeners), disposeListeners_1_1 = disposeListeners_1.next(); !disposeListeners_1_1.done; disposeListeners_1_1 = disposeListeners_1.next()) {
                var dispose = disposeListeners_1_1.value;
                dispose === null || dispose === void 0 ? void 0 : dispose();
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (disposeListeners_1_1 && !disposeListeners_1_1.done && (_a = disposeListeners_1.return)) _a.call(disposeListeners_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
};

var handleClient = function (_a) {
    var app = _a.app, transport = _a.transport, disposeServer = _a.disposeServer, disposeClient = _a.disposeClient, enablePatchesFilter = _a.enablePatchesFilter, preloadedState = _a.preloadedState;
    if (!transport) {
        throw new Error("The client transport does not exist.");
    }
    disposeServer === null || disposeServer === void 0 ? void 0 : disposeServer();
    disposeClient === null || disposeClient === void 0 ? void 0 : disposeClient();
    var container = app.instance[containerKey];
    var lastAction = container.get(LastAction);
    var portDetector = container.get(PortDetector);
    portDetector.setPort({ client: app }, transport);
    var disposeListeners = [];
    if (preloadedState) {
        lastAction.sequence = preloadedState[lastAction.stateKey]._sequence;
    }
    disposeListeners.push(transport.listen(lastActionName, function (action) { return __awaiter(void 0, void 0, void 0, function () {
        var currentState_1, _patches, patches, state;
        var _a;
        return __generator(this, function (_b) {
            if (portDetector.disableSyncClient)
                return [2 /*return*/];
            if (action._sequence && action._sequence === lastAction.sequence + 1) {
                if (action._reactant === actionIdentifier) {
                    currentState_1 = app.store.getState();
                    _patches = (_a = action._patches) !== null && _a !== void 0 ? _a : [];
                    patches = enablePatchesFilter
                        ? _patches.filter(function (item) { return currentState_1[item.path[0]]; })
                        : _patches;
                    state = applyPatches(currentState_1, patches);
                    app.store.dispatch(__assign(__assign({}, action), { state: state }));
                }
                else {
                    app.store.dispatch(action);
                }
                lastAction.sequence = action._sequence;
            }
            else {
                portDetector.syncFullState({ forceSync: false });
            }
            return [2 /*return*/];
        });
    }); }));
    disposeListeners.push(transport.listen(proxyServerActionName, function (_a) { return __awaiter(void 0, void 0, void 0, function () {
        var result;
        var clientIds = _a.clientIds, portName = _a.portName, options = __rest(_a, ["clientIds", "portName"]);
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    // ignore non-specified id or name of client
                    if ((Array.isArray(clientIds) &&
                        portDetector.clientId &&
                        !clientIds.includes(portDetector.clientId)) ||
                        (portName && portName !== portDetector.name))
                        return [2 /*return*/, new Promise(function () {
                                // never resolve
                            })];
                    return [4 /*yield*/, applyMethod(app, options)];
                case 1:
                    result = _b.sent();
                    return [2 /*return*/, result];
            }
        });
    }); }));
    disposeListeners.push(function () { return transport.dispose(); });
    return function () {
        var e_1, _a;
        try {
            for (var disposeListeners_1 = __values(disposeListeners), disposeListeners_1_1 = disposeListeners_1.next(); !disposeListeners_1_1.done; disposeListeners_1_1 = disposeListeners_1.next()) {
                var dispose = disposeListeners_1_1.value;
                dispose === null || dispose === void 0 ? void 0 : dispose();
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (disposeListeners_1_1 && !disposeListeners_1_1.done && (_a = disposeListeners_1.return)) _a.call(disposeListeners_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
};

var createBroadcastTransport = function (name, verbose) {
    var broadcastChannel = new BroadcastChannel("reactant-share-channel:".concat(name));
    var transport = createTransport('Base', {
        listener: function (callback) {
            broadcastChannel.onmessage = function (data) {
                callback(JSON.parse(data));
            };
            return function () {
                broadcastChannel.onmessage = null;
                return broadcastChannel.close();
            };
        },
        sender: function (message) { return broadcastChannel.postMessage(JSON.stringify(message)); },
        prefix: "reactant-share:".concat(name),
        verbose: verbose,
    });
    return transport;
};

var lockMap = new Map();
var tabId = createId();
var lockStorageKey = 'reactant:lock';
var tabStorageKey = 'reactant:tab';
var heartbeatTimer;
var isListenUnload = false;
var storage;
var clearTabLocks = function (tabIds, _storage) {
    if (tabIds.length === 0)
        return;
    Object.keys(localStorage).forEach(function (key) {
        var _a;
        if (!key.indexOf(lockStorageKey)) {
            var lockQueue = JSON.parse((_a = localStorage.getItem(key)) !== null && _a !== void 0 ? _a : '[]');
            var newValue = JSON.stringify(lockQueue.filter(function (item) { return tabIds.indexOf(item.tabId) === -1; }
            // && localStorage.getItem(`${tabStorageKey}:${item.tabId}`)
            ));
            _storage.setItem(key, newValue);
        }
    });
    tabIds.forEach(function (_tabId) { return _storage.removeItem("".concat(tabStorageKey, ":").concat(_tabId)); });
};
var addUnloadListener = function () {
    if (isListenUnload)
        return;
    isListenUnload = true;
    /**
     * After unload event, It is known that the clear of localStorage in some Firefox scenarios and Safari v10 does not execute properly.
     */
    window.addEventListener('pagehide', function () {
        // do not use `unload` event
        // https://developer.chrome.com/docs/web-platform/deprecating-unload
        clearTabLocks([tabId], localStorage);
    });
};
var filterInvalidTabs = function () {
    var invalidTabIds = [];
    Object.keys(localStorage).forEach(function (key) {
        var _a;
        if (!key.indexOf(tabStorageKey)) {
            var timestamp = localStorage.getItem(key);
            // TODO: think about Wakeup
            // Maximum is thread lock for 1 second + 1.99 second.
            if (timestamp && Date.now() - Number(timestamp) > 2999) {
                var expiredTabId = key.replace("".concat(tabStorageKey, ":"), '');
                invalidTabIds.push(expiredTabId);
            }
        }
        else if (!key.indexOf(lockStorageKey)) {
            var lockQueue = JSON.parse((_a = localStorage.getItem(key)) !== null && _a !== void 0 ? _a : '[]');
            lockQueue.forEach(function (item) {
                if (!localStorage.getItem("".concat(tabStorageKey, ":").concat(item.tabId))) {
                    invalidTabIds.push(item.tabId);
                }
            });
        }
    });
    return invalidTabIds;
};
var heartbeat = function () {
    if (typeof heartbeatTimer === 'undefined') {
        var tabHeartbeatKey_1 = "".concat(tabStorageKey, ":").concat(tabId);
        storage.setItem(tabHeartbeatKey_1, Date.now().toString());
        heartbeatTimer = window.setInterval(function () { return storage.setItem(tabHeartbeatKey_1, Date.now().toString()); }, 1000);
    }
};
var createFrameStorage = function () {
    var iframe = document.createElement('iframe');
    iframe.src = 'about:blank';
    iframe.setAttribute('style', 'display: none;');
    document.body.appendChild(iframe);
    storage = iframe.contentWindow.localStorage;
};
var simpleLock = function (name, callback) {
    createFrameStorage();
    addUnloadListener();
    heartbeat();
    return new Promise(function (resolve, reject) {
        var _a;
        var lockId = createId();
        lockMap.set(name, (_a = lockMap.get(name)) !== null && _a !== void 0 ? _a : new Map());
        lockMap.get(name).set(lockId, callback);
        var storageKey = "".concat(lockStorageKey, ":").concat(name);
        var oldStorageValue = localStorage.getItem(storageKey);
        var lockQueue = JSON.parse(oldStorageValue !== null && oldStorageValue !== void 0 ? oldStorageValue : '[]');
        lockQueue.push({ tabId: tabId, lockId: lockId });
        var listener = function (event) { return __awaiter(void 0, void 0, void 0, function () {
            var _a, lock, result, e_1, currentLockQueue;
            var _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!(event.key === storageKey && event.newValue)) return [3 /*break*/, 5];
                        _a = __read(JSON.parse(event.newValue), 1), lock = _a[0];
                        if (!((lock === null || lock === void 0 ? void 0 : lock.tabId) === tabId && (lock === null || lock === void 0 ? void 0 : lock.lockId) === lockId)) return [3 /*break*/, 5];
                        window.removeEventListener('storage', listener);
                        _c.label = 1;
                    case 1:
                        _c.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, lockMap.get(name).get(lockId)({
                                name: name,
                                mode: 'exclusive',
                            })];
                    case 2:
                        result = _c.sent();
                        resolve(result);
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _c.sent();
                        reject(e_1);
                        return [3 /*break*/, 4];
                    case 4:
                        lockMap.get(name).delete(lockId);
                        currentLockQueue = JSON.parse((_b = localStorage.getItem(storageKey)) !== null && _b !== void 0 ? _b : '[]');
                        currentLockQueue.splice(0, 1);
                        storage.setItem(storageKey, JSON.stringify(currentLockQueue));
                        _c.label = 5;
                    case 5: return [2 /*return*/];
                }
            });
        }); };
        window.addEventListener('storage', listener);
        storage.setItem(storageKey, JSON.stringify(lockQueue));
        clearTabLocks(filterInvalidTabs(), storage);
    });
};
var useLock = function (name, callback) {
    var _a;
    var isPrimitiveLock = !!((_a = navigator.locks) === null || _a === void 0 ? void 0 : _a.request);
    if (isPrimitiveLock) {
        return navigator.locks.request(name, callback).catch(function (e) {
            if (e.code === 18 && e.toString().startsWith('SecurityError')) {
                return simpleLock(name, callback);
            }
            return e;
        });
    }
    return simpleLock(name, callback);
};

var IdentifierChecker = /** @class */ (function (_super) {
    __extends(IdentifierChecker, _super);
    function IdentifierChecker() {
        var _this = _super.apply(this, __spreadArray([], __read(arguments), false)) || this;
        _this.beforeCombineRootReducers = function (reducers) {
            Object.keys(reducers).forEach(function (key) {
                var _a = __read(key.split('/'), 2), prefix = _a[0], className = _a[1];
                if (prefix === '@@reactant') {
                    console.error("The decorator for class ".concat(className, " should set \"@injectable({ name: '").concat(className, "' })\"."));
                }
            });
            return reducers;
        };
        return _this;
    }
    IdentifierChecker = __decorate([
        injectable()
    ], IdentifierChecker);
    return IdentifierChecker;
}(PluginModule));

var createBaseApp = function (_a) {
    var _b, _c, _d, _e;
    var share = _a.share, options = __rest(_a, ["share"]);
    (_b = options.modules) !== null && _b !== void 0 ? _b : (options.modules = []);
    (_c = options.devOptions) !== null && _c !== void 0 ? _c : (options.devOptions = {});
    options.devOptions.enablePatches = true;
    options.modules.push(LastAction, {
        provide: LastActionOptions,
        useFactory: function (moduleRef) {
            var portDetector;
            return {
                stateKey: "lastAction-".concat(share.name),
                // ignore router state and isolated state sync for last action
                ignoreAction: function (action) {
                    var _a, _b;
                    if (!portDetector) {
                        portDetector = moduleRef.get(PortDetector);
                    }
                    var firstPath = (_b = (_a = action._patches) === null || _a === void 0 ? void 0 : _a[0]) === null || _b === void 0 ? void 0 : _b.path[0];
                    return (action.type === LOCATION_CHANGE ||
                        (firstPath && portDetector.hasIsolatedState("".concat(firstPath))));
                },
            };
        },
        deps: [ModuleRef],
    }, {
        provide: SharedAppOptions,
        useValue: share,
    }, PortDetector);
    if (process.env.NODE_ENV !== 'production') {
        options.modules.push(IdentifierChecker);
    }
    if (share.enablePatchesChecker) {
        options.modules.push(PatchesChecker);
    }
    var app;
    var disposeServer;
    var disposeClient;
    var serverTransport = (_d = share.transports) === null || _d === void 0 ? void 0 : _d.server;
    var clientTransport = (_e = share.transports) === null || _e === void 0 ? void 0 : _e.client;
    var isServer = share.port === 'server';
    var transform = share.transform;
    share.transform = function (changedPort) {
        var _a, _b;
        var serverTransport = (_a = share.transports) === null || _a === void 0 ? void 0 : _a.server;
        var clientTransport = (_b = share.transports) === null || _b === void 0 ? void 0 : _b.client;
        if (changedPort === 'server') {
            if (!serverTransport) {
                throw new Error("'transports.server' does not exist.");
            }
            disposeServer = handleServer({
                app: app,
                transport: serverTransport,
                disposeServer: disposeServer,
                disposeClient: disposeClient,
                enablePatchesChecker: share.enablePatchesChecker,
            });
        }
        else {
            if (!clientTransport) {
                throw new Error("'transports.client' does not exist.");
            }
            disposeClient = handleClient({
                app: app,
                transport: clientTransport,
                disposeServer: disposeServer,
                disposeClient: disposeClient,
                enablePatchesFilter: share.enablePatchesFilter,
            });
        }
        transform === null || transform === void 0 ? void 0 : transform(changedPort);
    };
    app = createApp(options);
    if (share.port) {
        if (isServer) {
            if (!serverTransport) {
                throw new Error("'transports.server' does not exist.");
            }
            disposeServer = handleServer({
                app: app,
                transport: serverTransport,
                enablePatchesChecker: share.enablePatchesChecker,
            });
        }
        else {
            if (!clientTransport) {
                throw new Error("'transports.client' does not exist.");
            }
            disposeClient = handleClient({
                app: app,
                transport: clientTransport,
                enablePatchesFilter: share.enablePatchesFilter,
            });
        }
    }
    return app;
};
var createSharedTabApp = function (options) { return __awaiter(void 0, void 0, void 0, function () {
    var isSafari, app_1, app_2, app, isServer;
    var _a, _b, _c;
    var _d, _e, _f;
    return __generator(this, function (_g) {
        switch (_g.label) {
            case 0:
                if (process.env.NODE_ENV !== 'production' && options.share.forcedSyncClient === false) {
                    console.warn("'forcedSyncClient' must be enabled in 'SharedTab' mode");
                }
                options.share.forcedSyncClient = true;
                isSafari = /^((?!chrome|android).)*safari/i.test(navigator.userAgent);
                if (isSafari && !options.share.forcedShare) {
                    options.share.transports = {};
                    options.share.port = undefined;
                    options.share.type = 'Base';
                    app_1 = createBaseApp(options);
                    return [2 /*return*/, app_1];
                }
                (_a = (_d = options.share).transports) !== null && _a !== void 0 ? _a : (_d.transports = {});
                (_b = (_e = options.share.transports).client) !== null && _b !== void 0 ? _b : (_e.client = createBroadcastTransport(options.share.name, options.share.enableTransportDebugger));
                (_c = (_f = options.share.transports).server) !== null && _c !== void 0 ? _c : (_f.server = createBroadcastTransport(options.share.name, options.share.enableTransportDebugger));
                if (options.share.port) {
                    app_2 = createBaseApp(options);
                    return [2 /*return*/, app_2];
                }
                isServer = false;
                return [4 /*yield*/, Promise.race([
                        new Promise(function (resolve) {
                            // TODO: clear locks for testing in SharedTab mode
                            useLock("reactant-share-app-lock:".concat(options.share.name), function () { return __awaiter(void 0, void 0, void 0, function () {
                                var _a, _b;
                                return __generator(this, function (_c) {
                                    if (!app) {
                                        options.share.port = 'server';
                                        app = createBaseApp(options);
                                    }
                                    else {
                                        (_b = (_a = options.share).transform) === null || _b === void 0 ? void 0 : _b.call(_a, 'server');
                                    }
                                    isServer = true;
                                    resolve(app);
                                    return [2 /*return*/, new Promise(function () {
                                            //
                                        })];
                                });
                            }); });
                        }),
                        new Promise(function (resolve) { return __awaiter(void 0, void 0, void 0, function () {
                            var isClient, app_3;
                            var _a, _b;
                            return __generator(this, function (_c) {
                                switch (_c.label) {
                                    case 0: return [4 /*yield*/, ((_b = (_a = options.share.transports) === null || _a === void 0 ? void 0 : _a.client) === null || _b === void 0 ? void 0 : _b.emit(isClientName))];
                                    case 1:
                                        isClient = _c.sent();
                                        if (isClient && !isServer) {
                                            options.share.port = 'client';
                                            app_3 = createBaseApp(options);
                                            resolve(app_3);
                                        }
                                        return [2 /*return*/];
                                }
                            });
                        }); }),
                    ])];
            case 1:
                app = _g.sent();
                return [2 /*return*/, app];
        }
    });
}); };
/**
 * ## Description
 *
 * You can create an shared app with `createSharedApp()` passing app configuration,
 * which will asynchronously return an object including `instance`, `store`,
 * and `bootstrap()` method(You can run `bootstrap` to start the app inject into the browser or mobile).
 *
 * ## Example
 *
 * ```ts
 * import { createSharedApp, injectable, state, action, delegate, mockPairTransports } from 'reactant-share';
 *
 * @injectable({
 *   name: 'counter',
 * })
 * class Counter {
 *   @state
 *   count = 0;
 *
 *   @action
 *   increase() {
 *     this.count += 1;
 *   }
 * }
 *
 * export default async () => {
 *   const transports = mockPairTransports();
 *
 *   const server = await createSharedApp({
 *     modules: [],
 *     main: Counter,
 *     render: () => {},
 *     share: {
 *       name: 'counter',
 *       type: 'Base',
 *       port: 'server',
 *       transports: {
 *         server: transports[0],
 *       },
 *     },
 *   });
 *
 *   const client = await createSharedApp({
 *     modules: [],
 *     main: Counter,
 *     render: () => {},
 *     share: {
 *       name: 'counter',
 *       type: 'Base',
 *       port: 'client',
 *       transports: {
 *         client: transports[1],
 *       },
 *     },
 *   });
 *
 *   await delegate(client.instance, 'increase', []);
 *
 *   expect(client.instance.count).toBe(1);
 *   expect(server.instance.count).toBe(1);
 * };
 * ```
 */
var createSharedApp = function (options) { return __awaiter(void 0, void 0, void 0, function () {
    var app, transports, _a, e_1, _b, name_1, shareOptions, bootstrap;
    var _c, _d, _e, _f, _g, _h;
    var _j, _k;
    return __generator(this, function (_l) {
        switch (_l.label) {
            case 0:
                if (typeof options.share === 'undefined') {
                    throw new Error("'createSharedApp(options)' should be set 'share' option.");
                }
                // Check to minimized patch.
                (_c = (_j = options.share).enablePatchesChecker) !== null && _c !== void 0 ? _c : (_j.enablePatchesChecker = process.env.NODE_ENV !== 'production');
                // force Sync for all client
                (_d = (_k = options.share).forcedSyncClient) !== null && _d !== void 0 ? _d : (_k.forcedSyncClient = true);
                _a = options.share.type;
                switch (_a) {
                    case 'SharedWorker': return [3 /*break*/, 1];
                    case 'SharedTab': return [3 /*break*/, 5];
                    case 'Base': return [3 /*break*/, 7];
                }
                return [3 /*break*/, 8];
            case 1:
                _l.trys.push([1, 2, , 4]);
                transports = {
                    server: (_e = options.share.transports) === null || _e === void 0 ? void 0 : _e.server,
                    client: (_f = options.share.transports) === null || _f === void 0 ? void 0 : _f.client,
                };
                if (options.share.port === 'client' && options.share.worker) {
                    if (process.env.NODE_ENV !== 'production' && !transports.client) {
                        if (!(options.share.worker instanceof SharedWorker)) {
                            throw new Error("'options.share.worker' is not a SharedWorker instance.");
                        }
                    }
                    (_g = transports.client) !== null && _g !== void 0 ? _g : (transports.client = createTransport('SharedWorkerClient', {
                        worker: options.share.worker,
                        prefix: "reactant-share:".concat(options.share.name),
                        verbose: options.share.enableTransportDebugger,
                    }));
                }
                if (options.share.port === 'server') {
                    (_h = transports.server) !== null && _h !== void 0 ? _h : (transports.server = createTransport('SharedWorkerInternal', {
                        prefix: "reactant-share:".concat(options.share.name),
                        verbose: options.share.enableTransportDebugger,
                    }));
                }
                else if (options.share.port === 'client' && !transports.client) {
                    if (typeof options.share.workerURL !== 'string') {
                        throw new Error("The value of 'options.share.workerURL' should be a string.");
                    }
                    transports.client = createTransport('SharedWorkerClient', {
                        worker: new SharedWorker(options.share.workerURL),
                        prefix: "reactant-share:".concat(options.share.name),
                        verbose: options.share.enableTransportDebugger,
                    });
                }
                options.share.transports = transports;
                app = createBaseApp(options);
                return [3 /*break*/, 4];
            case 2:
                e_1 = _l.sent();
                console.warn(e_1);
                _b = options.share, _b.port, _b.workerURL, name_1 = _b.name, shareOptions = __rest(_b, ["port", "workerURL", "name"]);
                return [4 /*yield*/, createSharedTabApp(__assign(__assign({}, options), { share: __assign(__assign({}, shareOptions), { type: 'SharedTab', name: name_1, forcedSyncClient: true }) }))];
            case 3:
                app = _l.sent();
                return [3 /*break*/, 4];
            case 4: return [3 /*break*/, 9];
            case 5: return [4 /*yield*/, createSharedTabApp(options)];
            case 6:
                app = _l.sent();
                return [3 /*break*/, 9];
            case 7:
                app = createBaseApp(options);
                return [3 /*break*/, 9];
            case 8: throw new Error("The value of 'options.share.type' be 'SharedTab', 'SharedWorker' or 'Base'.");
            case 9:
                bootstrap = app.bootstrap;
                return [2 /*return*/, __assign(__assign({}, app), { destroy: function () {
                            var _a, _b, _c, _d;
                            app.destroy();
                            (_b = (_a = options.share.transports) === null || _a === void 0 ? void 0 : _a.client) === null || _b === void 0 ? void 0 : _b.dispose();
                            (_d = (_c = options.share.transports) === null || _c === void 0 ? void 0 : _c.server) === null || _d === void 0 ? void 0 : _d.dispose();
                        }, bootstrap: function () {
                            var args = [];
                            for (var _i = 0; _i < arguments.length; _i++) {
                                args[_i] = arguments[_i];
                            }
                            return __awaiter(void 0, void 0, void 0, function () {
                                var result, portDetector;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            result = bootstrap.apply(void 0, __spreadArray([], __read(args), false));
                                            portDetector = app.container.get(PortDetector);
                                            if (!portDetector.isClient) return [3 /*break*/, 2];
                                            return [4 /*yield*/, portDetector.syncFullStatePromise];
                                        case 1:
                                            _a.sent();
                                            _a.label = 2;
                                        case 2: return [2 /*return*/, result];
                                    }
                                });
                            });
                        } })];
        }
    });
}); };

/**
 * Proxy execute On the server side.
 *
 * ## Description
 *
 * `delegate()` is very similar to the actor model,
 *  which transfers the corresponding module method to the server thread for execution and returns the result as response.
 *
 * Note: It does not create new threads, it always runs on the server thread that has already been created.
 *
 * ## Example
 *
 * ```tsx
 * import React from 'react';
 * import { ViewModule, createApp, injectable, useConnector, action, state, delegate } from 'reactant-share';
 *
 * @injectable({ name: 'counter'})
 * class Counter {
 *   @state
 *   count = 0;
 *
 *   @action
 *   increase() {
 *     this.count += 1;
 *   }
 * }
 *
 * @injectable()
 * export class AppView extends ViewModule {
 *   constructor(public counter: Counter) {
 *     super();
 *   }
 *
 *   component() {
 *     const count = useConnector(() => this.counter.count);
 *     return (
 *       <button type="button" onClick={() => delegate(this.counter, 'increase', [])}>
 *         {count}
 *       </button>
 *     );
 *   }
 * }
 * ```
 * reference: https://en.wikipedia.org/wiki/Actor_model
 */
var delegate = (function (module, key, args, options) {
    var _a, _b;
    if (options === void 0) { options = {}; }
    var method = module[key];
    var _args = args !== null && args !== void 0 ? args : [];
    if (typeof key !== 'string') {
        throw new Error("'delegate()' is valid only for method name with string type.");
    }
    if (typeof method !== 'function') {
        throw new Error("The property '".concat(key, "'' must be a method in class '").concat(module.constructor.name, "'."));
    }
    if (!Array.isArray(_args)) {
        throw new Error("The parameters of the method '".concat(key, "' must be an array."));
    }
    var target = module;
    if ((_a = target[containerKey]) === null || _a === void 0 ? void 0 : _a.isBound(PortDetector)) {
        var portDetector_1 = target[containerKey].get(PortDetector);
        if (process.env.NODE_ENV !== 'production') {
            var moduleName = target.constructor.name;
            if (/^@@reactant/.test(target[identifierKey])) {
                throw new Error("The identifier '".concat(target[identifierKey], "' is a temporary string, please set 'provide' for the module '").concat(moduleName, "' or the 'name' field of the module '").concat(moduleName, "'."));
            }
        }
        // If the method in main thread and use coworker, it should be proxied for execution to a coworker thread.
        if (target[proxyExecutorKey]) {
            return target[proxyExecutorKey]({
                module: target[identifierKey],
                method: key,
                args: _args,
            });
        }
        // If the port is not a client, it just run the method in server port.
        if (portDetector_1.isClient) {
            if (!portDetector_1.transports.client) {
                return Promise.reject(new Error("Detected that the current client transport does not exist."));
            }
            return portDetector_1.transports.client
                .emit(__assign(__assign({}, options), { name: proxyClientActionName }), {
                module: target[identifierKey],
                method: key,
                args: _args,
                hook: (_b = options._extra) === null || _b === void 0 ? void 0 : _b.serverHook,
            })
                .then(function (response) {
                // If the response is undefined, it means that the method is not executed.
                if (!response)
                    return;
                var _a = __read(response, 2), sequence = _a[0], result = _a[1];
                if (portDetector_1.lastAction.sequence >= sequence) {
                    return result;
                }
                if (process.env.NODE_ENV !== 'production') {
                    console.warn("The sequence of the action is not consistent.", sequence, portDetector_1.lastAction.sequence);
                }
                return portDetector_1
                    .syncFullState({ forceSync: false })
                    .then(function () { return result; });
            });
        }
    }
    return method.apply(target, _args);
});

/**
 * Proxy execute On the client side.
 *
 * ## Description
 *
 * `fork()` is very similar to the actor model,
 *  which transfers the corresponding module method to all client threads for execution and returns the result from the first client's response.
 *
 * Note: It does not create new threads, it always runs on all client thread that have already been created.
 *
 * reference: https://en.wikipedia.org/wiki/Actor_model
 */
var fork = (function (module, key, _args, _options) {
    var args = _args !== null && _args !== void 0 ? _args : [];
    var _a = _options !== null && _options !== void 0 ? _options : {}, clientIds = _a.clientIds, portName = _a.portName, options = __rest(_a, ["clientIds", "portName"]);
    var method = module[key];
    if (typeof key !== 'string') {
        throw new Error("'fork()' is valid only for method name with string type.");
    }
    if (typeof method !== 'function') {
        throw new Error("The property '".concat(key, "'' must be a method in class '").concat(module.constructor.name, "'."));
    }
    if (!Array.isArray(args)) {
        throw new Error("The parameters of the method '".concat(key, "' must be an array."));
    }
    var target = module;
    if (target[containerKey].isBound(PortDetector)) {
        var portDetector = target[containerKey].get(PortDetector);
        if (!portDetector.isServer) {
            throw new Error("'fork()' should be running in server port.");
        }
        if (process.env.NODE_ENV !== 'production') {
            var moduleName = target.constructor.name;
            if (/^@@reactant/.test(target[identifierKey])) {
                throw new Error("The identifier '".concat(target[identifierKey], "' is a temporary string, please set 'provide' for the module '").concat(moduleName, "' or the 'name' field of the module '").concat(moduleName, "'."));
            }
        }
        if (!portDetector.transports.server) {
            return Promise.reject(new Error("Detected that the current server transport does not exist."));
        }
        return portDetector.transports.server.emit(__assign(__assign({}, options), { name: proxyServerActionName }), {
            module: target[identifierKey],
            method: key,
            args: args,
            clientIds: clientIds,
            portName: portName,
        });
    }
    return method.apply(target, args);
});

var ReactantRouter = /** @class */ (function (_super) {
    __extends(ReactantRouter, _super);
    function ReactantRouter(portDetector, sharedAppOptions, options) {
        var _a;
        var _this = _super.call(this, __assign(__assign({}, options), { autoCreateHistory: !((sharedAppOptions.type === 'SharedWorker' &&
                sharedAppOptions.port === 'server') ||
                !globalThis.document) })) || this;
        _this.portDetector = portDetector;
        _this.sharedAppOptions = sharedAppOptions;
        _this.options = options;
        _this.passiveRoute = false;
        _this.cachedHistory = [];
        _this.forwardHistory = [];
        /**
         * The timestamp of the last routing.
         */
        _this.lastRoutedTimestamp = Date.now();
        _this.toBeRouted = null;
        _this._routers = (_a = {},
            _a[_this.portDetector.name] = _this.router,
            _a);
        _this.defaultHistory = {
            action: 'POP',
            location: {
                pathname: _this.defaultRoute,
                search: '',
                hash: '',
                state: undefined,
            },
        };
        _this.firstRenderingSync = new Promise(function (resolve) {
            _this.firstRenderingSyncResolve = resolve;
        });
        _this.firstActiveSync = new Promise(function (resolve) {
            _this.firstActiveSyncResolve = resolve;
        });
        _this.firstClientSync = Promise.all([
            _this.firstRenderingSync,
            _this.firstActiveSync,
        ]);
        _this.portDetector.onClient(function () {
            var stopWatching = watch(_this, function () { return _this.portDetector.lastAction.action; }, function () {
                var action = _this.portDetector.lastAction
                    .action;
                if (action.type === LOCATION_CHANGE &&
                    action.payload.isFirstRendering) {
                    stopWatching();
                    var router = _this._routers[_this.portDetector.name];
                    if (router && _this.compareRouter(router, _this.router)) {
                        // router reducer @@router/LOCATION_CHANGE event and syncFullState event The events may be out of order, so we re-check route consistency after synchronizing the state.
                        _this.history.replace(router.location);
                    }
                    _this.firstRenderingSyncResolve();
                }
            });
        });
        if (globalThis.document) {
            window.addEventListener('popstate', function () {
                if (!_this.passiveRoute) {
                    _this.lastRoutedTimestamp = Date.now();
                }
            });
        }
        if (!_this.portDetector.shared) {
            var stopWatching_1 = _this.watchRehydratedRouting();
            watch(_this, function () { return _this.router; }, function () {
                if (_this.router) {
                    // just update the current router to routers mapping by name
                    _this._setRouters(_this.portDetector.name, _this.router);
                }
                if (!_this.enableCacheRouting) {
                    stopWatching_1();
                }
            });
        }
        _this.portDetector.onClient(function () {
            if (!_this.portDetector.sharedAppOptions.forcedSyncClient) {
                var visibilitychange_1 = function () { return __awaiter(_this, void 0, void 0, function () {
                    var fn;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                if (!(document.visibilityState === 'visible')) return [3 /*break*/, 2];
                                return [4 /*yield*/, this.portDetector.syncFullState({ forceSync: false })];
                            case 1:
                                _a.sent();
                                if (this.toBeRouted) {
                                    fn = this.toBeRouted;
                                    this.toBeRouted = null;
                                    fn();
                                }
                                _a.label = 2;
                            case 2: return [2 /*return*/];
                        }
                    });
                }); };
                document.addEventListener('visibilitychange', visibilitychange_1);
                return function () {
                    document.removeEventListener('visibilitychange', visibilitychange_1);
                };
            }
        });
        // #region sync init router from clients in Worker mode
        _this.portDetector.onServer(function (transport) {
            watch(_this, function () { return _this.router; }, function (router) {
                if (router &&
                    (!_this.cachedHistory[0] ||
                        _this.compareRouter(router, _this.cachedHistory[0]))) {
                    if (router.action === 'REPLACE') {
                        _this.cachedHistory[0] = router;
                    }
                    else {
                        _this.cachedHistory.unshift(router);
                    }
                    _this.cachedHistory.length = _this.maxHistoryLength; // Limit the length of the historical stack
                }
            });
            if (_this.portDetector.isWorkerMode && !_this.enableCacheRouting) {
                transport
                    .emit(syncWorkerRouterName, _this.portDetector.name)
                    .then(function (router) {
                    if (router) {
                        _this._changeRoutingOnSever(_this.portDetector.name, router, Date.now());
                    }
                });
            }
            else if (_this.enableCacheRouting) {
                return _this.watchRehydratedRouting();
            }
        });
        _this.portDetector.onClient(function (transport) {
            if (_this.portDetector.isWorkerMode) {
                return transport.listen(syncWorkerRouterName, function (name) { return __awaiter(_this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        if (name === this.portDetector.name) {
                            return [2 /*return*/, this.router];
                        }
                        return [2 /*return*/];
                    });
                }); });
            }
        });
        // #endregion
        // #region watch router and sync up router to all clients and server port
        _this.portDetector.onClient(function () {
            return watch(_this, function () { return _this.router; }, function () {
                delegate(_this, '_changeRoutingOnSever', [
                    _this.portDetector.name,
                    _this.router,
                    _this.lastRoutedTimestamp,
                    _this.portDetector.clientId,
                ]);
            });
        });
        _this.portDetector.onServer(function () {
            return watch(_this, function () { return _this.router; }, function () {
                if (!_this.portDetector.isWorkerMode) {
                    if (globalThis.document) {
                        // just update the current router to routers mapping by name at every time in shared tab mode
                        _this._setRouters(_this.portDetector.name, _this.router);
                    }
                    fork(_this, '_changeRoutingOnClient', [_this.portDetector.name, _this.router, _this.lastRoutedTimestamp], {
                        silent: true,
                    });
                }
            });
        });
        // #endregion
        // #region sync init router from server port in all modes
        _this.portDetector.onServer(function (transport) {
            var rehydratedPromise = _this.enableCacheRouting
                ? new Promise(function (resolve) {
                    var stopWatching = watch(_this, function () { var _a; return (_a = _this[stateKey]._persist) === null || _a === void 0 ? void 0 : _a.rehydrated; }, function (rehydrated) {
                        if (rehydrated) {
                            stopWatching();
                            resolve();
                        }
                    });
                })
                : Promise.resolve();
            return transport.listen(syncRouterName, function (name, timestamp, router) { return __awaiter(_this, void 0, void 0, function () {
                var currentRouter;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, rehydratedPromise];
                        case 1:
                            _a.sent();
                            currentRouter = this._routers[name];
                            if (!currentRouter && router) {
                                this._changeRoutingOnSever(name, router, timestamp);
                            }
                            return [2 /*return*/, currentRouter];
                    }
                });
            }); });
        });
        _this.portDetector.onClient(function (transport) {
            transport
                .emit(syncRouterName, _this.portDetector.name, _this.lastRoutedTimestamp, _this.router)
                .then(function (router) {
                if (!router) {
                    _this.firstActiveSyncResolve();
                    return;
                }
                _this.passiveRoute = true;
                _this.history.replace(router.location);
                _this.passiveRoute = false;
                _this.firstActiveSyncResolve();
            });
        });
        return _this;
        // #endregion
    }
    Object.defineProperty(ReactantRouter.prototype, "maxHistoryLength", {
        get: function () {
            var _a;
            return (_a = this.options.maxHistoryLength) !== null && _a !== void 0 ? _a : 50;
        },
        enumerable: false,
        configurable: true
    });
    ReactantRouter.prototype.watchRehydratedRouting = function () {
        var _this = this;
        // The first rendering and the hydration of the persistent router may emit actions in a different order due to the module order.
        var firstTrigger = false;
        var stopWatchingRehydrated = watch(this, function () { var _a; return (_a = _this[stateKey]._persist) === null || _a === void 0 ? void 0 : _a.rehydrated; }, function (rehydrated) {
            if (!_this.enableCacheRouting) {
                stopWatchingRehydrated();
            }
            if (rehydrated) {
                stopWatchingRehydrated();
                if (!firstTrigger) {
                    firstTrigger = true;
                    return;
                }
                var router = _this._routers[_this.portDetector.name];
                _this._changeRoutingOnSever(_this.portDetector.name, router !== null && router !== void 0 ? router : _this.defaultHistory, Date.now());
            }
        });
        var stopWatchingIsFirstRendering = watch(this, function () { return _this.portDetector.lastAction.action; }, function () {
            if (!_this.enableCacheRouting) {
                stopWatchingIsFirstRendering();
            }
            var action = _this.portDetector.lastAction
                .action;
            if (action.type === LOCATION_CHANGE &&
                action.payload.isFirstRendering) {
                stopWatchingIsFirstRendering();
                if (!firstTrigger) {
                    firstTrigger = true;
                    return;
                }
                var router = _this._routers[_this.portDetector.name];
                _this._changeRoutingOnSever(_this.portDetector.name, router !== null && router !== void 0 ? router : _this.defaultHistory, Date.now());
            }
        });
        return function () {
            stopWatchingRehydrated();
            stopWatchingIsFirstRendering();
        };
    };
    ReactantRouter.prototype.compareRouter = function (router1, router2) {
        return (router1.location.pathname !== router2.location.pathname ||
            router1.location.hash !== router2.location.hash ||
            router1.location.search !== router2.location.search ||
            JSON.stringify(router1.location.state) !==
                JSON.stringify(router2.location.state) ||
            JSON.stringify(router1.location.query) !==
                JSON.stringify(router2.location.query));
    };
    ReactantRouter.prototype._changeRoutingOnSever = function (name, router, timestamp, clientId) {
        if (!this.portDetector.isServerWorker && globalThis.document) {
            // Only update the latest routes
            if (this.lastRoutedTimestamp >= timestamp)
                return;
            this.lastRoutedTimestamp = timestamp;
        }
        this._setRouters(name, router);
        if (name === this.portDetector.name) {
            if (this.portDetector.isWorkerMode) {
                this.dispatchChanged(router);
            }
            else if (this.compareRouter(router, this.router)) {
                this.passiveRoute = true;
                this.history.push(router.location);
                this.passiveRoute = false;
            }
            if (this.portDetector.shared) {
                fork(this, '_changeRoutingOnClient', [this.portDetector.name, this.router, timestamp], {
                    silent: true,
                    clientIds: clientId
                        ? //  Skip routing the origin of the client
                            this.portDetector.clientIds.filter(function (id) { return id !== clientId; })
                        : undefined,
                });
            }
        }
        else if (this.portDetector.shared) {
            fork(this, '_changeRoutingOnClient', [name, router, timestamp], {
                silent: true,
                clientIds: clientId
                    ? //  Skip routing the origin of the client
                        this.portDetector.clientIds.filter(function (id) { return id !== clientId; })
                    : undefined,
            });
        }
    };
    ReactantRouter.prototype._changeRoutingOnClient = function (name, router, timestamp) {
        var _this = this;
        // if the client is the non-origin of the routing, skip it
        // or if the timestamp of the routing is earlier than the last routing, skip it
        if (name !== this.portDetector.name ||
            (timestamp && this.lastRoutedTimestamp >= timestamp))
            return;
        var route = function () {
            if (_this.history && _this.compareRouter(router, _this.router)) {
                _this.passiveRoute = true;
                _this.history.push(router.location);
                _this.passiveRoute = false;
            }
        };
        if (this.portDetector.disableSyncClient) {
            this.toBeRouted = route;
        }
        else {
            route();
        }
    };
    ReactantRouter.prototype._makeRoutingOnClient = function (_a) {
        var _this = this;
        var args = _a.args, action = _a.action, name = _a.name;
        return new Promise(function (resolve) {
            var route = function () {
                if (name === _this.portDetector.name) {
                    // eslint-disable-next-line @typescript-eslint/ban-ts-comment
                    // @ts-ignore
                    _super.prototype[action].apply(_this, __spreadArray([], __read(args), false));
                    resolve(_this.router);
                }
            };
            if (_this.portDetector.disableSyncClient) {
                _this.toBeRouted = route;
            }
            else {
                route();
            }
        });
    };
    ReactantRouter.prototype._setRouters = function (name, router) {
        var _a;
        if (!this.enableCacheRouting ||
            (this.enableCacheRouting && ((_a = this[stateKey]._persist) === null || _a === void 0 ? void 0 : _a.rehydrated))) {
            this._routers[name] = router;
        }
    };
    Object.defineProperty(ReactantRouter.prototype, "defaultRoute", {
        // The server port routing state is received asynchronously, so there should be a default route.
        get: function () {
            var _a;
            return (_a = this.options.defaultRoute) !== null && _a !== void 0 ? _a : '/';
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ReactantRouter.prototype, "enableCacheRouting", {
        get: function () {
            var _a, _b;
            var Storage = this[modulesKey][storageModuleName];
            var routerPersistConfig = Storage === null || Storage === void 0 ? void 0 : Storage.persistConfig[routerModuleName];
            return (routerPersistConfig &&
                (((_a = routerPersistConfig.whitelist) === null || _a === void 0 ? void 0 : _a.includes('_routers')) ||
                    ((_b = routerPersistConfig.blacklist) === null || _b === void 0 ? void 0 : _b.includes('_routers')) === false));
        },
        enumerable: false,
        configurable: true
    });
    ReactantRouter.prototype.dispatchChanged = function (router) {
        var _a;
        if (!router)
            return;
        (_a = this.store) === null || _a === void 0 ? void 0 : _a.dispatch(this.onLocationChanged(router.location, router.action));
    };
    Object.defineProperty(ReactantRouter.prototype, "currentPath", {
        get: function () {
            var _a, _b;
            return (_b = (_a = this.router) === null || _a === void 0 ? void 0 : _a.location.pathname) !== null && _b !== void 0 ? _b : this.defaultRoute;
        },
        enumerable: false,
        configurable: true
    });
    ReactantRouter.prototype.push = function (path, locationState) {
        return __awaiter(this, void 0, void 0, function () {
            var router;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.portDetector.isServerWorker) return [3 /*break*/, 2];
                        return [4 /*yield*/, fork(this, '_makeRoutingOnClient', [
                                {
                                    args: [path, locationState],
                                    action: 'push',
                                    name: this.portDetector.name,
                                },
                            ])];
                    case 1:
                        router = _a.sent();
                        this.dispatchChanged(router);
                        return [3 /*break*/, 3];
                    case 2:
                        this.lastRoutedTimestamp = Date.now();
                        _super.prototype.push.call(this, path, locationState);
                        _a.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    ReactantRouter.prototype.replace = function (path, locationState) {
        return __awaiter(this, void 0, void 0, function () {
            var router;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.portDetector.isServerWorker) return [3 /*break*/, 2];
                        return [4 /*yield*/, fork(this, '_makeRoutingOnClient', [
                                {
                                    args: [path, locationState],
                                    action: 'replace',
                                    name: this.portDetector.name,
                                },
                            ])];
                    case 1:
                        router = _a.sent();
                        this.dispatchChanged(router);
                        return [3 /*break*/, 3];
                    case 2:
                        this.lastRoutedTimestamp = Date.now();
                        _super.prototype.replace.call(this, path, locationState);
                        _a.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    ReactantRouter.prototype.go = function (n) {
        return __awaiter(this, void 0, void 0, function () {
            var stepsBack, currentRouter, targetRouter, router, stepsForward, targetRouter, router;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.portDetector.shared) {
                            this.lastRoutedTimestamp = Date.now();
                            _super.prototype.go.call(this, n);
                            return [2 /*return*/];
                        }
                        if (this.portDetector.isClient) {
                            return [2 /*return*/, delegate(this, 'go', [n])];
                        }
                        if (!(n < 0)) return [3 /*break*/, 6];
                        stepsBack = Math.abs(n);
                        if (!(this.cachedHistory.length > stepsBack)) return [3 /*break*/, 4];
                        currentRouter = this.cachedHistory.shift();
                        this.forwardHistory.unshift(currentRouter); // Add to forward history
                        targetRouter = this.cachedHistory[stepsBack - 1];
                        if (!targetRouter) return [3 /*break*/, 2];
                        return [4 /*yield*/, fork(this, '_makeRoutingOnClient', [
                                {
                                    args: [
                                        targetRouter.location.pathname,
                                        targetRouter.location.state,
                                    ],
                                    action: 'replace',
                                    name: this.portDetector.name,
                                },
                            ])];
                    case 1:
                        router = _a.sent();
                        this.dispatchChanged(router);
                        return [3 /*break*/, 3];
                    case 2:
                        console.warn('No more history to go back.');
                        _a.label = 3;
                    case 3: return [3 /*break*/, 5];
                    case 4:
                        console.warn('No more history to go back.');
                        _a.label = 5;
                    case 5: return [3 /*break*/, 13];
                    case 6:
                        if (!(n > 0)) return [3 /*break*/, 12];
                        stepsForward = n;
                        if (!(this.forwardHistory.length >= stepsForward)) return [3 /*break*/, 10];
                        targetRouter = this.forwardHistory[stepsForward - 1];
                        if (!targetRouter) return [3 /*break*/, 8];
                        return [4 /*yield*/, fork(this, '_makeRoutingOnClient', [
                                {
                                    args: [
                                        targetRouter.location.pathname,
                                        targetRouter.location.state,
                                    ],
                                    action: 'push',
                                    name: this.portDetector.name,
                                },
                            ])];
                    case 7:
                        router = _a.sent();
                        this.dispatchChanged(router);
                        return [3 /*break*/, 9];
                    case 8:
                        console.warn('No more history to go forward.');
                        _a.label = 9;
                    case 9:
                        // Remove the used entry from the forward stack
                        this.forwardHistory.splice(0, stepsForward);
                        return [3 /*break*/, 11];
                    case 10:
                        console.warn('No more history to go forward.');
                        _a.label = 11;
                    case 11: return [3 /*break*/, 13];
                    case 12:
                        // Go to the current route (refresh the page)
                        console.warn('Going to the current route (n = 0) does nothing.');
                        _a.label = 13;
                    case 13: return [2 /*return*/];
                }
            });
        });
    };
    ReactantRouter.prototype.goBack = function () {
        return __awaiter(this, void 0, void 0, function () {
            var currentRouter, previousRouter, router;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.portDetector.shared) {
                            this.lastRoutedTimestamp = Date.now();
                            _super.prototype.goBack.call(this);
                            return [2 /*return*/];
                        }
                        if (this.portDetector.isClient) {
                            return [2 /*return*/, delegate(this, 'goBack', [])];
                        }
                        if (!(this.cachedHistory.length > 1)) return [3 /*break*/, 4];
                        currentRouter = this.cachedHistory.shift();
                        this.forwardHistory.unshift(currentRouter); // Push to forward stack
                        this.forwardHistory.length = this.maxHistoryLength; // Limit the length of the forward stack
                        previousRouter = this.cachedHistory[0];
                        if (!previousRouter) return [3 /*break*/, 2];
                        return [4 /*yield*/, fork(this, '_makeRoutingOnClient', [
                                {
                                    args: [
                                        previousRouter.location.pathname,
                                        previousRouter.location.state,
                                    ],
                                    action: 'push',
                                    name: this.portDetector.name,
                                },
                            ])];
                    case 1:
                        router = _a.sent();
                        this.dispatchChanged(router);
                        return [3 /*break*/, 3];
                    case 2:
                        console.warn('No forward route available.');
                        _a.label = 3;
                    case 3: return [3 /*break*/, 5];
                    case 4:
                        console.warn('No previous route available.');
                        _a.label = 5;
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    ReactantRouter.prototype.goForward = function () {
        return __awaiter(this, void 0, void 0, function () {
            var nextRouter, router;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.portDetector.shared) {
                            this.lastRoutedTimestamp = Date.now();
                            _super.prototype.goForward.call(this);
                            return [2 /*return*/];
                        }
                        if (this.portDetector.isClient) {
                            return [2 /*return*/, delegate(this, 'goForward', [])];
                        }
                        if (!(this.forwardHistory.length > 0)) return [3 /*break*/, 3];
                        nextRouter = this.forwardHistory.shift();
                        if (!nextRouter) return [3 /*break*/, 2];
                        return [4 /*yield*/, fork(this, '_makeRoutingOnClient', [
                                {
                                    args: [nextRouter.location.pathname, nextRouter.location.state],
                                    action: 'push',
                                    name: this.portDetector.name,
                                },
                            ])];
                    case 1:
                        router = _a.sent();
                        this.dispatchChanged(router);
                        _a.label = 2;
                    case 2: return [3 /*break*/, 4];
                    case 3:
                        console.warn('No forward route available.');
                        _a.label = 4;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    __decorate([
        state,
        __metadata("design:type", Object)
    ], ReactantRouter.prototype, "_routers", void 0);
    __decorate([
        action,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [String, Object]),
        __metadata("design:returntype", void 0)
    ], ReactantRouter.prototype, "_setRouters", null);
    ReactantRouter = __decorate([
        injectable({
            name: routerModuleName,
        }),
        __param(1, inject(SharedAppOptions)),
        __param(2, inject(RouterOptions)),
        __metadata("design:paramtypes", [PortDetector, Object, Object])
    ], ReactantRouter);
    return ReactantRouter;
}(Router));

var CoworkerOptions = Symbol('CoworkerOptions');
var Coworker = /** @class */ (function (_super) {
    __extends(Coworker, _super);
    function Coworker(portDetector, coworkerOptions, storage) {
        var _a, _b;
        var _this = _super.call(this) || this;
        _this.portDetector = portDetector;
        _this.coworkerOptions = coworkerOptions;
        _this.storage = storage;
        _this.proxyModuleKeys = [];
        _this.ignoreSyncStateKeys = (_b = (_a = _this.coworkerOptions) === null || _a === void 0 ? void 0 : _a.ignoreSyncStateKeys) !== null && _b !== void 0 ? _b : [];
        _this.afterCreateStore = function (store) {
            _this.applyProxyExecute();
            _this.applyProxyModules(_this.proxyModules);
            _this.applyProxyState();
            if (_this.isCoworker) {
                if (_this.sequence === -1) {
                    _this.sequence = 0;
                    _this.pushAllState();
                }
                if (_this.storage) {
                    // sync up last state when proxy module state is rehydrated
                    _this.proxyModules.forEach(function (serviceIdentifier) {
                        var modules = _this.ref.container.getAll(serviceIdentifier);
                        modules.forEach(function (module) {
                            if (_this.storage.storageSettingMap.has(module)) {
                                var stopWatching_1 = watch(module, function () { return _this.storage.getRehydrated(module); }, function (rehydrated) {
                                    if (rehydrated) {
                                        stopWatching_1();
                                        var _a = getRef(module), identifier = _a.identifier, state = _a.state;
                                        _this.sequence += 1;
                                        // If the coworker runs before the main thread,
                                        // then the sequence will ensure that the state is properly synchronized.
                                        _this.transport.emit({ name: syncStateName, respond: false }, {
                                            _reactant: actionIdentifier,
                                            type: "".concat(actionIdentifier, "_").concat(syncModuleStateActionName),
                                            params: [],
                                            _patches: [
                                                {
                                                    op: 'replace',
                                                    path: [identifier],
                                                    value: state,
                                                },
                                            ],
                                        }, _this.sequence);
                                    }
                                });
                            }
                        });
                    });
                }
            }
            if (_this.isMain && _this.sequence === -1) {
                _this.requestSyncAllState();
            }
            return store;
        };
        _this.sequence = -1;
        if (!_this.portDetector.isClient) {
            _this.transport = _this.createTransport();
        }
        _this.proxyModules = __spreadArray([], __read(_this.coworkerOptions.useModules), false);
        if (_this.isCoworker && _this.enablePatchesChecker) {
            // stricter checks to prevent cross-module state updates.
            _this.middleware = function (store) { return function (next) { return function (_action) {
                var _patches = _action._patches, type = _action.type, method = _action.method;
                // skip check for storage module change any state
                if (type === storageModuleName)
                    return next(_action);
                var hasCoworkerState;
                _patches === null || _patches === void 0 ? void 0 : _patches.forEach(function (_a, index) {
                    var path = _a.path; _a.op; _a.value;
                    var _hasCoworkerState = _this.proxyModuleKeys.includes("".concat(path[0]));
                    // ignore first patch
                    if (!index) {
                        hasCoworkerState = _hasCoworkerState;
                    }
                    else if (hasCoworkerState !== _hasCoworkerState) {
                        var methodName = "".concat(type, ".").concat(method);
                        throw new Error("Update state error: Mixed update of coworker proxy state and isolated state is not supported, please check method '".concat(methodName, "'."));
                    }
                });
                return next(_action);
            }; }; };
        }
        if (_this.storage && _this.isMain) {
            // main thread should ignore proxy module storage state
            _this.storage.beforeCombinePersistReducer = function () {
                var proxyModules = [];
                _this.proxyModules.forEach(function (serviceIdentifier) {
                    var modules = _this.ref.container.getAll(serviceIdentifier);
                    proxyModules.push.apply(proxyModules, __spreadArray([], __read(modules), false));
                });
                _this.storage.storageSettingMap.forEach(function (_, module) {
                    if (proxyModules.includes(module)) {
                        _this.storage.storageSettingMap.delete(module);
                    }
                });
            };
        }
        return _this;
    }
    Coworker.prototype.createTransport = function () {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l;
        if (this.portDetector.isWorkerMode) {
            if (this.isCoworker) {
                return ((_b = (_a = this.coworkerOptions.transports) === null || _a === void 0 ? void 0 : _a.coworker) !== null && _b !== void 0 ? _b : createTransport('Broadcast', {
                    prefix: this.prefix,
                    verbose: (_c = this.coworkerOptions) === null || _c === void 0 ? void 0 : _c.enableTransportDebugger,
                }));
            }
            if (this.portDetector.sharedAppOptions.port === 'server') {
                return ((_e = (_d = this.coworkerOptions.transports) === null || _d === void 0 ? void 0 : _d.main) !== null && _e !== void 0 ? _e : createTransport('Broadcast', {
                    prefix: this.prefix,
                    verbose: (_f = this.coworkerOptions) === null || _f === void 0 ? void 0 : _f.enableTransportDebugger,
                }));
            }
        }
        else if (this.isCoworker) {
            var isWebWorker = !globalThis.SharedWorkerGlobalScope &&
                globalThis.WorkerGlobalScope;
            return ((_h = (_g = this.coworkerOptions.transports) === null || _g === void 0 ? void 0 : _g.coworker) !== null && _h !== void 0 ? _h : createTransport(isWebWorker ? 'WebWorkerInternal' : 'SharedWorkerInternal', {
                prefix: this.prefix,
                verbose: (_j = this.coworkerOptions) === null || _j === void 0 ? void 0 : _j.enableTransportDebugger,
            }));
        }
        else if (this.portDetector.sharedAppOptions.port !== 'client') {
            if ((_k = this.coworkerOptions.transports) === null || _k === void 0 ? void 0 : _k.main) {
                return this.coworkerOptions.transports.main;
            }
            if (!((_l = this.coworkerOptions) === null || _l === void 0 ? void 0 : _l.worker)) {
                if (process.env.NODE_ENV !== 'production')
                    console.warn('No coworker support in server port.');
                return;
            }
            if (this.coworkerOptions.worker instanceof Worker) {
                return createTransport('WebWorkerClient', {
                    worker: this.coworkerOptions.worker,
                    prefix: this.prefix,
                    verbose: this.coworkerOptions.enableTransportDebugger,
                });
            }
            return createTransport('SharedWorkerClient', {
                worker: this.coworkerOptions.worker,
                prefix: this.prefix,
                verbose: this.coworkerOptions.enableTransportDebugger,
            });
        }
    };
    Object.defineProperty(Coworker.prototype, "prefix", {
        get: function () {
            return "reactant-share:".concat(this.portDetector.sharedAppOptions.name, ":coworker:").concat(this.name);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Coworker.prototype, "name", {
        get: function () {
            return this[nameKey];
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Coworker.prototype, "isCoworker", {
        /**
         * Whether the current thread is the coworker thread.
         */
        get: function () {
            return this.coworkerOptions.isCoworker;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Coworker.prototype, "isMain", {
        /**
         * Whether the current thread is the main thread.
         */
        get: function () {
            return !this.isCoworker && !!this.transport;
        },
        enumerable: false,
        configurable: true
    });
    // TODO: fix dynamic module with storage state
    /**
     * Add proxy modules.
     */
    Coworker.prototype.addProxyModules = function (modules) {
        var _a;
        if (process.env.NODE_ENV !== 'production') {
            if (!Array.isArray(modules)) {
                throw new TypeError("Expected an array, but received: ".concat(typeof modules));
            }
        }
        (_a = this.proxyModules).push.apply(_a, __spreadArray([], __read(modules), false));
    };
    /**
     * Add ignore sync state keys
     */
    Coworker.prototype.addIgnoreSyncStateKeys = function (keys) {
        var _a;
        (_a = this.ignoreSyncStateKeys).push.apply(_a, __spreadArray([], __read(keys), false));
    };
    Object.defineProperty(Coworker.prototype, "enablePatchesChecker", {
        get: function () {
            var _a, _b;
            return (_b = (_a = this.coworkerOptions) === null || _a === void 0 ? void 0 : _a.enablePatchesChecker) !== null && _b !== void 0 ? _b : process.env.NODE_ENV !== 'production';
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Coworker.prototype, "ref", {
        get: function () {
            return getRef(this);
        },
        enumerable: false,
        configurable: true
    });
    Coworker.prototype.applyProxyState = function () {
        var _this = this;
        if (this.isMain) {
            this.transport.listen(pushAllStateName, function (options) { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    this.handleSyncAllState(options);
                    return [2 /*return*/];
                });
            }); });
            this.transport.listen(syncStateName, function (action, coworkerSequence) { return __awaiter(_this, void 0, void 0, function () {
                var currentState, _sequence, state;
                return __generator(this, function (_a) {
                    // If the sequence is not continuous, it means that the main thread need sync all state from coworker thread.
                    if (this.sequence + 1 !== coworkerSequence) {
                        this.requestSyncAllState();
                        return [2 /*return*/];
                    }
                    currentState = this.ref.store.getState();
                    _sequence = this.portDetector.lastAction.sequence;
                    state = applyPatches(currentState, action._patches);
                    this.ignoreStates(state, currentState);
                    this.ref.store.dispatch(__assign(__assign({}, action), { state: state, _sequence: _sequence }));
                    this.sequence = coworkerSequence;
                    return [2 /*return*/];
                });
            }); });
        }
        if (this.isCoworker) {
            watch(this, function () { return _this.portDetector.lastAction.action; }, function (lastAction) {
                var _a;
                var _patches = (_a = lastAction._patches) === null || _a === void 0 ? void 0 : _a.filter(function (_a) {
                    var path = _a.path;
                    var _b = __read(path, 2), module = _b[0], key = _b[1];
                    return (_this.proxyModuleKeys.includes(module) &&
                        !_this.ignoreSyncStateKeys.includes(key));
                });
                if (!_patches || _patches.length === 0)
                    return;
                _this.sequence += 1;
                // If the coworker runs before the main thread,
                // then the sequence will ensure that the state is properly synchronized.
                _this.transport.emit({ name: syncStateName, respond: false }, __assign(__assign({}, lastAction), { _patches: _patches }), _this.sequence);
            });
            this.transport.listen(requestSyncAllStateName, function () { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    this.pushAllState();
                    return [2 /*return*/];
                });
            }); });
        }
    };
    Coworker.prototype.pushAllState = function () {
        var _this = this;
        var currentState = this.ref.store.getState();
        var state = {};
        this.proxyModuleKeys.forEach(function (key) {
            state[key] = __assign({}, currentState[key]);
            _this.ignoreSyncStateKeys.forEach(function (ignoreKey) {
                delete state[key][ignoreKey];
            });
        });
        this.transport.emit({ name: pushAllStateName, respond: false }, {
            state: state,
            sequence: this.sequence,
        });
    };
    Coworker.prototype.handleSyncAllState = function (options) {
        if (options.sequence === this.sequence && this.sequence !== -1) {
            return;
        }
        this.sequence = options.sequence;
        var currentState = this.ref.store.getState();
        var _sequence = this.portDetector.lastAction.sequence;
        var state = __assign(__assign({}, currentState), options.state);
        this.ignoreStates(state, currentState);
        this.ref.store.dispatch({
            _reactant: actionIdentifier,
            type: "".concat(actionIdentifier, "_").concat(syncStateActionName),
            state: state,
            _sequence: _sequence,
        });
    };
    Coworker.prototype.requestSyncAllState = function () {
        this.transport.emit({ name: requestSyncAllStateName, respond: false });
    };
    Coworker.prototype.ignoreStates = function (state, currentState) {
        var _this = this;
        this.ignoreSyncStateKeys.forEach(function (ignoreKey) {
            _this.proxyModuleKeys.forEach(function (key) {
                state[key][ignoreKey] = currentState[key][ignoreKey];
            });
        });
    };
    Coworker.prototype.applyProxyExecute = function () {
        var _this = this;
        if (this.isCoworker) {
            this.transport.listen(proxyWorkerExecuteName, function (_a) { return __awaiter(_this, [_a], void 0, function (_b) {
                var instance;
                var _c;
                var module = _b.module, method = _b.method, args = _b.args;
                return __generator(this, function (_d) {
                    instance = this.ref.modules[module];
                    if (process.env.NODE_ENV !== 'production' && typeof instance[method] !== 'function') {
                        console.warn("The method \"".concat(method, "\" does not exist in the module \"").concat(module, "\"."));
                    }
                    return [2 /*return*/, (_c = instance[method]) === null || _c === void 0 ? void 0 : _c.call.apply(_c, __spreadArray([instance], __read(args), false))];
                });
            }); });
        }
    };
    Coworker.prototype.applyProxyModules = function (proxyModules) {
        var _this = this;
        proxyModules.forEach(function (serviceIdentifier) {
            var modules = _this.ref.container.getAll(serviceIdentifier);
            modules.forEach(function (module) {
                if (_this.portDetector.isolatedModules.includes(module)) {
                    throw new Error("\n            The module \"".concat(serviceIdentifier.toString(), "\" is isolated, and cannot be used as a proxy module in '").concat(_this.name, "' coworker.\n          "));
                }
                if (process.env.NODE_ENV !== 'production' && module[coworkerKey]) {
                    console.warn("The proxy module \"".concat(serviceIdentifier.toString(), "\" with \"").concat(_this.name, "\" coworker already exists."));
                }
                module[coworkerKey] = _this;
                _this.proxyModuleKeys.push(getRef(module).identifier);
                if (_this.isMain) {
                    if (process.env.NODE_ENV !== 'production' && module[proxyExecutorKey]) {
                        console.warn("The proxy module \"".concat(serviceIdentifier.toString(), "\" with \"").concat(_this.name, "\" already exists."));
                    }
                    module[proxyExecutorKey] = function (execParams) {
                        return _this.transport.emit(proxyWorkerExecuteName, execParams);
                    };
                }
            });
        });
    };
    Coworker = __decorate([
        injectable({
            name: 'Coworker',
        }),
        __param(1, inject(CoworkerOptions)),
        __param(2, optional()),
        __metadata("design:paramtypes", [PortDetector, Object, ReactantStorage])
    ], Coworker);
    return Coworker;
}(PluginModule));
var ICoworker = Coworker;
var createCoworker = function (name) {
    var CoworkerOptions = Symbol("".concat(name, "CoworkerOptions"));
    var Coworker = /** @class */ (function (_super) {
        __extends(Coworker, _super);
        function Coworker(portDetector, coworkerOptions, storage) {
            var _this = _super.call(this, portDetector, coworkerOptions, storage) || this;
            _this.portDetector = portDetector;
            _this.coworkerOptions = coworkerOptions;
            _this.storage = storage;
            return _this;
        }
        Coworker = __decorate([
            injectable({
                name: "".concat(name, "Coworker"),
            }),
            __param(1, inject(CoworkerOptions)),
            __param(2, optional()),
            __metadata("design:paramtypes", [PortDetector, Object, ReactantStorage])
        ], Coworker);
        return Coworker;
    }(ICoworker));
    return [Coworker, CoworkerOptions];
};
var getCoworker = function (instance) {
    return instance === null || instance === void 0 ? void 0 : instance[coworkerKey];
};

/**
 * mock pair transports
 */
var mockPairTransports = function () {
    var _a = mockPorts(), create = _a.create, main = _a.main;
    return [createTransport('Base', main), createTransport('Base', create())];
};

export { Coworker, CoworkerOptions, PortDetector, ReactantRouter as Router, SharedAppOptions, ReactantStorage as Storage, applyMethod, coworkerKey, createBroadcastTransport, createCoworker, createSharedApp, delegate, fork, getCoworker, isClientName, lastActionName, loadFullStateActionName, mockPairTransports, preloadedStateActionName, proxyClientActionName, proxyExecutorKey, proxyServerActionName, proxyWorkerExecuteName, pushAllStateName, removeClientIdToServerName, requestSyncAllStateName, routerModuleName, storageModuleName, syncClientIdToServerName, syncClientIdsFromClientsName, syncModuleStateActionName, syncRouterName, syncStateActionName, syncStateName, syncToClientsName, syncWorkerRouterName, useLock };
