import { Storage as BaseReactantStorage, StorageOptions, REHYDRATE, getRehydrated } from 'reactant-storage';
import type { IStorageOptions as IBaseStorageOptions, SetStorageOptions } from 'reactant-storage';
import { PortDetector } from './portDetector';
export interface IStorageOptions extends IBaseStorageOptions {
    /**
     * disable client rehydrated
     */
    disableClientRehydrated?: boolean;
}
declare class ReactantStorage extends BaseReactantStorage {
    protected portDetector: PortDetector;
    options: IStorageOptions;
    constructor(portDetector: PortDetector, options: IStorageOptions);
    /**
     * set module to storage persistent
     */
    setStorage<T extends object>(target: T, options: SetStorageOptions<T>): any;
}
export { ReactantStorage as Storage, StorageOptions, REHYDRATE, SetStorageOptions, getRehydrated, };
//# sourceMappingURL=storage.d.ts.map